/******************************************************************************/
/*                                                                            */
/*        Project: Boona Taxi                                                 */
/*          Title: Frame counter for IRIX                                     */
/*        Version: 0.3                                                        */
/*                                                                            */
/*        Started: 20/09/2000                                                 */
/*   Last Updated: 24/11/2000                                                 */
/*                                                                            */
/*        Authors: Michael Bonnington, Rob Bateman                            */
/*                                                                            */
/******************************************************************************/

#include <stdio.h>
#include <time.h>
#include "./frametime.h"



/* Globals ===================================================================*/
double framestart, frameend, frametime;
timespec_t tm;



/* Frame counter - initialise ================================================*/
int initFrameCounter(void)
{
   framestart = ftime();
   printf("Found hi-res clock.\n\n");

   /*rate_inv = 1.0/(double)CLOCKS_PER_SEC;
   printf("No hi-res clock - using less accurate time() instead\n\n");*/

   return 1;   /* There is a clock */
}

/* Frame counter - get the timer's value and divide by its rate ==============*/
double ftime(void)
{
   clock_gettime(CLOCK_REALTIME,&tm);
   return tm.tv_sec + (tm.tv_nsec / 1e9);

   /*return clock()*rate_inv;*/
}

/* Frame counter - work out current frametime ================================*/
double getFrametime(void)
{
   do{
      frameend=ftime();
   }while(frameend==framestart);

   frametime=frameend-framestart;
   framestart=frameend;

   return frametime;
}
