/******************************************************************************/
/*                                                                            */
/*        Project: Puzzle Ruckus                                              */
/*          Title: Tetris header file                                         */
/*        Version: 0.2                                                        */
/*                                                                            */
/*        Started: 10/01/2001                                                 */
/*   Last Updated: 28/01/2001                                                 */
/*                                                                            */
/*         Author: Michael Bonnington                                         */
/*                                                                            */
/******************************************************************************/

#ifndef TETRIS_H
#define TETRIS_H

#include "./win32.h"
#include <stdlib.h>



/* Class definitions =========================================================*/
class tetris
{
   public:
      int score, lines, level, opponent_energy, attack, character_offset;
      float power;
      bool display_next_block;
      bool game_over;
      float pos_x, pos_y;   //position of block

      bool grid[12][25];
      bool current_block[4][4];

      //constructor function...
      tetris(int initial_level=0)
      {
         reset(initial_level);
      }

      //destructor function...
      ~tetris(void)
      {
      }

      //function prototypes...
      void reset(int);
      void clearGrid(void);
      void initNewBlock(int);
      void changeBlock(int);
      void tempBlock(int);
      void moveBlock(int);
      void dropBlock(double);
      void rotateBlock(bool);
      bool checkCollision(int);
      bool checkRotate(void);
      void checkLines(void);
      void dropGrid(int);
      void setBlock(void);
      int randomBlock(void);
      bool update(bool, double);

      //query functions
      inline bool getNextBlock(int x, int y)
      {
         return possible_blocks[next_block_type][y][x];
      }

   private:
      float drop;   //position of block

      int current_block_type;
      int next_block_type;

      bool temp_block[4][4];
      static bool possible_blocks[19][4][4];
};



#endif

